// -*- C++ -*-
/*!
 * @file  ConvertToMotor.cpp
 * @brief Convert PS4 Contrller Value
 * @date $Date$
 *
 * $Id$
 */

#include "ConvertToMotor.h"

// Module specification
// <rtc-template block="module_spec">
static const char* converttomotor_spec[] =
  {
    "implementation_id", "ConvertToMotor",
    "type_name",         "ConvertToMotor",
    "description",       "Convert PS4 Contrller Value",
    "version",           "1.0.0",
    "vendor",            "FSK",
    "category",          "Converter",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
ConvertToMotor::ConvertToMotor(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_Controller_TypeIn("Controller_Type", m_Controller_Type),
    m_ButtonIn("Button", m_Button),
    m_AnalogIn("Analog", m_Analog),
    m_ServoMotorValue1Out("ServoMotor1", m_ServoMotorValue1),
    m_ServoMotorValue2Out("ServoMotor2", m_ServoMotorValue2),
    m_ServoMotorValue3Out("ServoMotor3", m_ServoMotorValue3)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
ConvertToMotor::~ConvertToMotor()
{
}



RTC::ReturnCode_t ConvertToMotor::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("Controller_Type", m_Controller_TypeIn);
  addInPort("Button", m_ButtonIn);
  addInPort("Analog", m_AnalogIn);
  
  // Set OutPort buffer
  addOutPort("ServoMotor1", m_ServoMotorValue1Out);
  addOutPort("ServoMotor2", m_ServoMotorValue2Out);
  addOutPort("ServoMotor3", m_ServoMotorValue3Out);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  // <rtc-template block="bind_config">
  // </rtc-template>
  button_input = 0;
  long f = 1;
  for (int i = 0; i < 16; i++)
  {
	  binary_number[i] = f << i;
	  std::cout << "bin num[" << i << "]:" << binary_number[i] << std::endl;
	  button[i] = 0;
  }
  m_ServoMotorValue1.data = 90;
  m_ServoMotorValue2.data = 90;
  m_ServoMotorValue3.data = 90;
  //T[{[^1̍őpxAŏpxAω
  servo1limitmax = 180;
  servo1limitmin = 0;
  servo1value = 2;
  //T[{[^2̍őpxAŏpxAω
  servo2limitmax = 180;
  servo2limitmin = 0;
  servo2value = 2;
  //T[{[^3̍őpxAŏpxAω
  servo3limitmax = 180;
  servo3limitmin = 0;
  servo3value = 2;
  //DC[^PWMl
  dc1value = 100;
  dc2value = 100;
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t ConvertToMotor::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ConvertToMotor::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ConvertToMotor::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t ConvertToMotor::onActivated(RTC::UniqueId ec_id)
{
	std::cout << "onActivated" << std::endl;
	for (int i = 0; i < 16; i++)button[i] = 0;

	butonFlag = false;
	AnalogFlag = false;

	a = 0;
  return RTC::RTC_OK;
}


RTC::ReturnCode_t ConvertToMotor::onDeactivated(RTC::UniqueId ec_id)
{
	std::cout << "onDeactivated" << std::endl;

	std::cout << "ServoMotor1:" << m_ServoMotorValue1.data << " ServoMotor2:" << m_ServoMotorValue2.data << " ServoMotor3:" << m_ServoMotorValue3.data << std::endl;

  return RTC::RTC_OK;
}


RTC::ReturnCode_t ConvertToMotor::onExecute(RTC::UniqueId ec_id)
{
	AnalogFlag = false;
	butonFlag = false;

	if (m_Controller_TypeIn.isNew())
	{
		m_Controller_TypeIn.read();
		std::cout << m_Controller_Type.data << std::endl;
	}
	if (m_ButtonIn.isNew())//PS4̃{^Ă邩mF
	{
		m_ButtonIn.read();
		button_input = m_Button.data;
		std::cout << "button_input:" << button_input << "b:";
		for (int i = 0; i < 16; i++)
		{
			if (button_input >= binary_number[15 - i]){//ǂ̃{^Ă邩mF
				button[15 - i] = 1;
				button_input = button_input - binary_number[15 - i];
			}
			else
			{
				button[15 - i] = 0;
			}
			std::cout << button[15 - i];
		}
		std::cout << std::endl;
		butonFlag = true;
	}
	if (m_AnalogIn.isNew())
	{

		std::cout << "Analog:";
		m_AnalogIn.read();
		for (int i = 0; i < 8; i++){
			Analog[i] = m_Analog.data[i];
			std::cout << Analog[i] << ",";
		}
		a = 1;
		std::cout << std::endl;
		AnalogFlag = true;
		a = 3;

		a = 4;

	}
	ServoMotorOut();
	std::cout << "Smotor1:" << m_ServoMotorValue1.data << " Smotor2:" << m_ServoMotorValue2.data << " Smotor3:" << m_ServoMotorValue3.data << std::endl;

  return RTC::RTC_OK;
}
void ConvertToMotor::ServoMotorOut()
{
	//T[{[^1̍őpxAŏpxAω
	servo1limitmax = 180;
	servo1limitmin = 0;
	servo1value = 1;
	//T[{[^2̍őpxAŏpxAω
	servo2limitmax = 180;
	servo2limitmin = 0;
	servo2value = 1;
	//T[{[^3̍őpxAŏpxAω
	servo3limitmax = 180;
	servo3limitmin = 0;
	servo3value = 1;

	if (AnalogFlag == true)
	{
		if (Analog[2]> 0){//XeBbNɌXĂƂ
			m_ServoMotorValue2.data += (int)(Analog[2] * servo2value);//px
			if (m_ServoMotorValue2.data > servo1limitmax)
				m_ServoMotorValue2.data = servo1limitmax;
		}
		else{//XeBbNEɌXĂƂ
			m_ServoMotorValue2.data += (int)(Analog[2] * servo2value);//px
			if (m_ServoMotorValue2.data < servo1limitmin)
				m_ServoMotorValue2.data = servo1limitmin;
		}
		if (Analog[3]> 0){//XeBbNɌXĂƂ
			m_ServoMotorValue3.data += (int)(Analog[3] * servo3value);
			if (m_ServoMotorValue3.data > servo2limitmax)
				m_ServoMotorValue3.data = servo2limitmax;
		}
		else{//XeBbNɌXĂƂ
			m_ServoMotorValue3.data += (int)(Analog[3] * servo3value);
			if (m_ServoMotorValue3.data < servo2limitmin)
				m_ServoMotorValue3.data = servo2limitmin;
		}

		m_ServoMotorValue2Out.write();
		m_ServoMotorValue3Out.write();
	}
	if (butonFlag == true)
	{
		if (button[3] == 1){//{^Ăꍇ
			m_ServoMotorValue1.data += servo1value;//T[{[^3̊px
			if (m_ServoMotorValue1.data > servo1limitmax)
				m_ServoMotorValue1.data = servo1limitmax;
		}
		if (button[2] == 1){//{^Ăꍇ
			m_ServoMotorValue1.data -= servo1value;//T[{[^3̊px
			if (m_ServoMotorValue1.data < servo1limitmin)
				m_ServoMotorValue1.data = servo1limitmin;
		}
		m_ServoMotorValue1Out.write();
	}

}
/*
RTC::ReturnCode_t ConvertToMotor::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t ConvertToMotor::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t ConvertToMotor::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ConvertToMotor::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ConvertToMotor::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void ConvertToMotorInit(RTC::Manager* manager)
  {
    coil::Properties profile(converttomotor_spec);
    manager->registerFactory(profile,
                             RTC::Create<ConvertToMotor>,
                             RTC::Delete<ConvertToMotor>);
  }
  
};


